# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class Folder(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'error_details': 'ErrorDetails',
        'filter': 'Filter',
        'folder_id': 'str',
        'folders': 'list[Folder]',
        'name': 'str',
        'owner_email': 'str',
        'owner_user_id': 'str',
        'owner_user_name': 'str',
        'parent_folder_id': 'str',
        'parent_folder_uri': 'str',
        'type': 'str',
        'uri': 'str'
    }

    attribute_map = {
        'error_details': 'errorDetails',
        'filter': 'filter',
        'folder_id': 'folderId',
        'folders': 'folders',
        'name': 'name',
        'owner_email': 'ownerEmail',
        'owner_user_id': 'ownerUserId',
        'owner_user_name': 'ownerUserName',
        'parent_folder_id': 'parentFolderId',
        'parent_folder_uri': 'parentFolderUri',
        'type': 'type',
        'uri': 'uri'
    }

    def __init__(self, error_details=None, filter=None, folder_id=None, folders=None, name=None, owner_email=None, owner_user_id=None, owner_user_name=None, parent_folder_id=None, parent_folder_uri=None, type=None, uri=None):  # noqa: E501
        """Folder - a model defined in Swagger"""  # noqa: E501

        self._error_details = None
        self._filter = None
        self._folder_id = None
        self._folders = None
        self._name = None
        self._owner_email = None
        self._owner_user_id = None
        self._owner_user_name = None
        self._parent_folder_id = None
        self._parent_folder_uri = None
        self._type = None
        self._uri = None
        self.discriminator = None

        if error_details is not None:
            self.error_details = error_details
        if filter is not None:
            self.filter = filter
        if folder_id is not None:
            self.folder_id = folder_id
        if folders is not None:
            self.folders = folders
        if name is not None:
            self.name = name
        if owner_email is not None:
            self.owner_email = owner_email
        if owner_user_id is not None:
            self.owner_user_id = owner_user_id
        if owner_user_name is not None:
            self.owner_user_name = owner_user_name
        if parent_folder_id is not None:
            self.parent_folder_id = parent_folder_id
        if parent_folder_uri is not None:
            self.parent_folder_uri = parent_folder_uri
        if type is not None:
            self.type = type
        if uri is not None:
            self.uri = uri

    @property
    def error_details(self):
        """Gets the error_details of this Folder.  # noqa: E501


        :return: The error_details of this Folder.  # noqa: E501
        :rtype: ErrorDetails
        """
        return self._error_details

    @error_details.setter
    def error_details(self, error_details):
        """Sets the error_details of this Folder.


        :param error_details: The error_details of this Folder.  # noqa: E501
        :type: ErrorDetails
        """

        self._error_details = error_details

    @property
    def filter(self):
        """Gets the filter of this Folder.  # noqa: E501


        :return: The filter of this Folder.  # noqa: E501
        :rtype: Filter
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """Sets the filter of this Folder.


        :param filter: The filter of this Folder.  # noqa: E501
        :type: Filter
        """

        self._filter = filter

    @property
    def folder_id(self):
        """Gets the folder_id of this Folder.  # noqa: E501

          # noqa: E501

        :return: The folder_id of this Folder.  # noqa: E501
        :rtype: str
        """
        return self._folder_id

    @folder_id.setter
    def folder_id(self, folder_id):
        """Sets the folder_id of this Folder.

          # noqa: E501

        :param folder_id: The folder_id of this Folder.  # noqa: E501
        :type: str
        """

        self._folder_id = folder_id

    @property
    def folders(self):
        """Gets the folders of this Folder.  # noqa: E501

        A collection of folder objects returned in a response.  # noqa: E501

        :return: The folders of this Folder.  # noqa: E501
        :rtype: list[Folder]
        """
        return self._folders

    @folders.setter
    def folders(self, folders):
        """Sets the folders of this Folder.

        A collection of folder objects returned in a response.  # noqa: E501

        :param folders: The folders of this Folder.  # noqa: E501
        :type: list[Folder]
        """

        self._folders = folders

    @property
    def name(self):
        """Gets the name of this Folder.  # noqa: E501

          # noqa: E501

        :return: The name of this Folder.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Folder.

          # noqa: E501

        :param name: The name of this Folder.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def owner_email(self):
        """Gets the owner_email of this Folder.  # noqa: E501

          # noqa: E501

        :return: The owner_email of this Folder.  # noqa: E501
        :rtype: str
        """
        return self._owner_email

    @owner_email.setter
    def owner_email(self, owner_email):
        """Sets the owner_email of this Folder.

          # noqa: E501

        :param owner_email: The owner_email of this Folder.  # noqa: E501
        :type: str
        """

        self._owner_email = owner_email

    @property
    def owner_user_id(self):
        """Gets the owner_user_id of this Folder.  # noqa: E501

          # noqa: E501

        :return: The owner_user_id of this Folder.  # noqa: E501
        :rtype: str
        """
        return self._owner_user_id

    @owner_user_id.setter
    def owner_user_id(self, owner_user_id):
        """Sets the owner_user_id of this Folder.

          # noqa: E501

        :param owner_user_id: The owner_user_id of this Folder.  # noqa: E501
        :type: str
        """

        self._owner_user_id = owner_user_id

    @property
    def owner_user_name(self):
        """Gets the owner_user_name of this Folder.  # noqa: E501

          # noqa: E501

        :return: The owner_user_name of this Folder.  # noqa: E501
        :rtype: str
        """
        return self._owner_user_name

    @owner_user_name.setter
    def owner_user_name(self, owner_user_name):
        """Sets the owner_user_name of this Folder.

          # noqa: E501

        :param owner_user_name: The owner_user_name of this Folder.  # noqa: E501
        :type: str
        """

        self._owner_user_name = owner_user_name

    @property
    def parent_folder_id(self):
        """Gets the parent_folder_id of this Folder.  # noqa: E501

          # noqa: E501

        :return: The parent_folder_id of this Folder.  # noqa: E501
        :rtype: str
        """
        return self._parent_folder_id

    @parent_folder_id.setter
    def parent_folder_id(self, parent_folder_id):
        """Sets the parent_folder_id of this Folder.

          # noqa: E501

        :param parent_folder_id: The parent_folder_id of this Folder.  # noqa: E501
        :type: str
        """

        self._parent_folder_id = parent_folder_id

    @property
    def parent_folder_uri(self):
        """Gets the parent_folder_uri of this Folder.  # noqa: E501

          # noqa: E501

        :return: The parent_folder_uri of this Folder.  # noqa: E501
        :rtype: str
        """
        return self._parent_folder_uri

    @parent_folder_uri.setter
    def parent_folder_uri(self, parent_folder_uri):
        """Sets the parent_folder_uri of this Folder.

          # noqa: E501

        :param parent_folder_uri: The parent_folder_uri of this Folder.  # noqa: E501
        :type: str
        """

        self._parent_folder_uri = parent_folder_uri

    @property
    def type(self):
        """Gets the type of this Folder.  # noqa: E501

          # noqa: E501

        :return: The type of this Folder.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Folder.

          # noqa: E501

        :param type: The type of this Folder.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def uri(self):
        """Gets the uri of this Folder.  # noqa: E501

          # noqa: E501

        :return: The uri of this Folder.  # noqa: E501
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """Sets the uri of this Folder.

          # noqa: E501

        :param uri: The uri of this Folder.  # noqa: E501
        :type: str
        """

        self._uri = uri

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Folder, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Folder):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
